<template>
  <div class="menuSettings_box">
    <!-- 角色，单位 -->
    <div class="menuSettings_tree">
      <div class="content_box">
        <My-bread :list="[
            `${$t('operatManage.operatManage')}`,
            `${$t('operatManage.RoleMenuAuthorization')}`,
          ]"></My-bread>
        <el-divider />
        <el-form
          ref="form"
          :model="selFrom"
        >
          <el-form-item label="单位">
            <el-select
              ref="multiSelect"
              style="width: 300px; "
              v-model="selFrom.name"
              placeholder="请选择单位名称..."
              @change="chooseCustom('multiSelect')"
            >
              <el-option
                :value="selectTree"
                style="overflow: auto; backgrond: transparent;    height: 100%;"
                disabled
              >
                <el-tree
                  :data="depList"
                  :props="defaultProps"
                  :check-on-click-node="true"
                  :check-strictly="true"
                  node-key="id"
                  ref="treeForm"
                  @node-click="addAdminHandleNodeClick"
                  :default-expanded-keys="[1]"
                >
                </el-tree>
              </el-option>
            </el-select>
          </el-form-item>
        </el-form>
        <el-table
          :data="tableData"
          style="width: 100%"
          @row-click="singleElection"
          highlight-current-row
          height="78%"
        >
          <el-table-column
            align="center"
            width="55"
          >
            <template slot-scope="scope">
              <el-radio
                class="radio"
                v-model="templateSelection"
                :label="scope.row.id"
              >&nbsp;</el-radio>
            </template>
          </el-table-column>
          <el-table-column
            align="center"
            type="index"
            :label="$t('dataManage.styleObj.index')"
          />
          <el-table-column
            prop="name"
            :label="$t('operatManage.UserRoleAuthorizationObj.name')"
          >
          </el-table-column>
        </el-table>
      </div>
      <div class="content_box">
        <div style="
            font-size: 14px;
            color: #216fe6;
            line-height: 1;
            cursor: text;
            position: relative;
            top: 5px;
            margin-left: 10px;
            display: flex;
            align-items: center;
          ">
          <span>
            {{ $t('operatManage.UserRoleAuthorizationObj.menuTable') }}</span>
        </div>
        <el-divider />
        <div class="menuContent">
          <el-tree
            :data="menuList"
            :props="defaultMenuProps"
            :show-checkbox="false"
            :check-on-click-node="true"
            :check-strictly="true"
            node-key="id"
            @check="menuTreeCheck"
            ref="treeForm"
            :default-expanded-keys="[1]"
          >
          </el-tree>
        </div>
      </div>
      <div class="content_box">
        <div style="
            font-size: 14px;
            color: #216fe6;
            line-height: 1;
            cursor: text;
            position: relative;
            top: 5px;
            margin-left: 10px;
            display: flex;
            align-items: center;
          ">
          <span>
            {{
              $t('operatManage.UserRoleAuthorizationObj.PermissionTable')
            }}</span>
          <div
            class="btn"
            style="margin-left: auto"
          >
            <el-button
              v-if="menuStatus.insert"
              type="primary"
              icon="el-icon-circle-plus-outline"
              size="small"
              @click="adduser"
              :disabled="menuid == null ? true : false"
            >{{
                $t('operatManage.UserRoleAuthorizationObj.Added')
              }}</el-button>
            <el-button
              v-if="menuStatus.delete"
              type="danger"
              icon="el-icon-delete"
              size="small"
              @click="deletesUser"
              :disabled="menuid == null ? true : false"
            >{{
                $t('operatManage.UserRoleAuthorizationObj.delete')
              }}</el-button>
          </div>
        </div>
        <el-divider class="divider" />
        <el-table
          :data="menuTableData"
          stripe
          style="width: 100%"
          height="78%"
          @selection-change="handleSelectionChange"
        >
          <el-table-column
            type="selection"
            width="55"
          > </el-table-column>
          <el-table-column
            align="center"
            type="index"
            :label="$t('dataManage.styleObj.index')"
          />
          <el-table-column
            prop="name"
            :label="$t('operatManage.UserRoleAuthorizationObj.name')"
          >
          </el-table-column>
        </el-table>

        <div
          style="margin-top: 20px; text-align: center"
          class="pagination_box"
        >
          <el-pagination
            @size-change="authhandleSizeChange"
            @current-change="authhandleCurrentChange"
            :current-page="rolMenuListData.pageIndex"
            :page-sizes="[10, 20, 30, 40]"
            :page-size="rolMenuListData.pageSize"
            layout="prev, pager, next"
            :total="roleMenuCount"
          >
          </el-pagination>
        </div>
      </div>

    </div>

    <el-dialog
      :title="$t('operatManage.UserRoleAuthorizationObj.Added')"
      :visible.sync="dialogTableVisible"
    >
      <el-table
        :data="gridData"
        height="40vh"
        @selection-change="addhandleSelectionChange"
      >
        <el-table-column
          type="selection"
          width="55"
        > </el-table-column>
        <el-table-column
          align="center"
          type="index"
          :label="$t('dataManage.styleObj.index')"
        />
        <el-table-column
          prop="name"
          :label="$t('operatManage.UserRoleAuthorizationObj.name')"
        >
        </el-table-column>
      </el-table>
      <div
        style="margin-top: 20px; text-align: center"
        class="pagination_box"
      >
        <el-pagination
          @size-change="addhandleSizeChange"
          @current-change="addhandleCurrentChange"
          :current-page="addlistData.pageIndex"
          :page-sizes="[10, 20, 30, 40]"
          :page-size="addlistData.pageSize"
          layout="total, sizes, prev, pager, next, jumper"
          :total="addcount"
        >
        </el-pagination>
      </div>
      <div
        slot="footer"
        class="dialog-footer"
      >
        <el-button
          size="small"
          @click="dialogTableVisible = false"
        >{{
          $t('dataManage.dictionaryManageObj.cancel')
        }}</el-button>
        <el-button
          size="small"
          type="primary"
          @click="addConfirm"
        >{{ $t('dataManage.dictionaryManageObj.confirm') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import MyBread from '../../components/MyBread.vue';
import {
  queryDepTree,
  select_Role_ByPageAndCount,
  selectMenuRecursives,
  roleMenuAuthelectByPageForRole,
  menuAuthSelectByPageForRole,
  roleMenuAuthInserts,
  roleMenuAuthDeletes,
} from '../../api/api';
export default {
  //import引入的组件需要注入到对象中才能使用
  components: {
    MyBread,
  },

  data() {
    return {
      dialogTableVisible: false,
      selFrom: { name: '' },
      selectTree: '',
      depList: [], //el树数据
      defaultProps: {
        children: 'children',
        label: 'name',
      }, //树绑定对象
      defaultMenuProps: {
        children: 'children',
        label: 'cnName',
      }, //菜单表绑定权限
      depid: null, //单位ID
      roleDepListData: {
        pageIndex: 1,
        pageSize: 10,
      },
      rolMenuListData: {
        pageIndex: 1,
        pageSize: 10,
      },
      addlistData: { pageIndex: 1, pageSize: 10 },
      addcount: 0,
      roleDepCount: 0,
      roleMenuCount: 0,
      roleDepCheckList: [],

      tableData: [], //角色列表
      templateSelection: '',
      menuList: [],
      roleid: null,
      menuid: null,
      menuTableData: [],
      gridData: [],
      addmultipleSelection: [],
      usermultipleSelection: [],
      menuStatus: {
        delete: false,
        insert: false,
        update: false,
      },
    };
  },
  methods: {
    async getDepTree() {
      //获取目录树最大ID，新建节点使用
      const data = await queryDepTree();
      if (data.code !== 200) {
        return this.$message.error('请求单位报错');
      }
      this.depList = this.treeData(data.result);
    },
    async getMenuTree() {
      const data = await selectMenuRecursives({ name: menuStartName });
      if (data.code !== 200) {
        return this.$message.error('请求单位报错');
      }

      this.menuList = this.treeData(data.result);
    },
    treeData(source) {
      let cloneData = JSON.parse(JSON.stringify(source)); // 对源数据深度克隆
      return cloneData.filter((father) => {
        // 循环所有项
        let branchArr = cloneData.filter((child) => father.id == child.pid); // 对比ID，分别上下级菜单，并返回数据
        branchArr.length > 0 ? (father.children = branchArr) : ''; // 给父级添加一个children属性，并赋值
        return father.pid == 0; // 返回一级菜单
      });
    },
    //树选中节点
    addAdminHandleNodeClick(e) {
      this.roleDepCheckList = [];
      this.templateSelection = '';
      this.depid = e.id;
      this.selFrom.name = e.name;
      this.selectTree = e.name;
      this.chooseCustom('multiSelect');
      this.getRoleDep();
      this.getMenuTree();
    },
    menuTreeCheck(node, list) {
      if (list.checkedNodes.length > 0) {
        if (this.roleid == null) return;
        this.rolMenuListData.menuid = node.id;
        this.menuid = node.id;
        this.rolMenuListData.roleid = this.roleid;
        this.getRoleMenu();
        if (list.checkedKeys.length == 2) {
          //单选实现
          this.$refs.treeForm.setCheckedKeys([node.id]);
        }
      } else {
        this.menuid = null;
      }
    },
    async getRoleMenu() {
      const data = await roleMenuAuthelectByPageForRole(this.rolMenuListData);
      if (data.code !== 200) {
        return this.$message.error('角色菜单请求错误');
      }
      this.menuTableData = data.result;
      this.roleMenuCount = data.count;
    },
    async getRoleDep() {
      this.roleDepListData.depid = this.depid;
      const data = await select_Role_ByPageAndCount(this.roleDepListData);
      if (data.code !== 200) {
        return this.$message.error('用户角色请求错误');
      }
      this.tableData = data.result;
      this.roleDepCount = data.count;
    },
    async getadduserList() {
      this.addlistData.roleid = this.roleid;
      this.addlistData.menuid = this.menuid;
      const data = await menuAuthSelectByPageForRole(this.addlistData);
      if (data.code !== 200) {
        return this.$message.error('菜单权限列表请求错误');
      }
      this.gridData = data.result;
      this.addcount = data.count;
    },
    singleElection(row) {
      this.getMenuTree();
      this.menuTableData = [];
      this.roleMenuCount = 0;
      this.templateSelection = row.id;
      this.roleid = row.id;

      this.roleDepCheckList = this.tableData.filter(
        (item) => item.id === row.id
      );
    },
    //下拉框选中后自动关闭
    chooseCustom(refName) {
      // this.$refs[refName] && this.$refs[refName].blur();
      this.createTimer(this.autoCloseSelect, refName);
    },
    createTimer(callback, refName) {
      const timer = setTimeout(() => {
        callback(refName);
      }, 50);
      this.$once('hook:beforeDestroy', () => {
        clearInterval(timer);
      });
    },
    autoCloseSelect(refName) {
      this.$refs[refName] && this.$refs[refName].blur();
    },
    dephandleSizeChange() {
      this.roleDepListData.pageSize = val;
      this.getDepTree();
    },
    dephandleCurrentChange() {
      this.roleDepListData.pageIndex = val;
      this.getDepTree();
    },
    authhandleSizeChange() {
      this.roleDepListData.pageSize = val;
      this.getRoleMenu();
    },
    authhandleCurrentChange() {
      this.roleDepListData.pageIndex = val;
      this.getRoleMenu();
    },
    // 新增用户表分页
    addhandleSizeChange(val) {
      this.addlistData.pageSize = val;
      this.getadduserList();
    },
    // 新增用户表分页
    addhandleCurrentChange(val) {
      this.addlistData.pageIndex = val;
      this.getadduserList();
    },
    addhandleSelectionChange(val) {
      this.addmultipleSelection = val;
    },
    handleSelectionChange(val) {
      this.usermultipleSelection = val;
    },
    adduser() {
      this.dialogTableVisible = true;
      this.getadduserList();
    },
    async deletesUser() {
      let arr = [];
      this.usermultipleSelection.forEach((e) => {
        arr.push(e.id);
      });
      const data = await roleMenuAuthDeletes({ ids: arr.toString() });
      if (data.code !== 200) {
        return this.$message.error('删除失败');
      }
      this.$message({
        message: '删除成功',
        type: 'success',
      });
      this.getRoleMenu();
    },
    addConfirm() {
      this.$confirm('确定是否新增', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
      })
        .then(async () => {
          let arr = [];
          this.addmultipleSelection.forEach((e) => {
            arr.push({ menuAuthId: e.id, roleid: this.roleid });
          });
          const data = await roleMenuAuthInserts(arr);
          if (data.code !== 200) {
            return this.$message.error('新增失败');
          }

          this.$message({
            type: 'success',
            message: '新增成功!',
          });
          this.dialogTableVisible = false;
          this.getRoleMenu();
        })
        .catch(() => { });
    },
    showPermsMenu(res) {
      switch (res.tag) {
        case '/delete':
          this.menuStatus.delete = true;
          break;
        case '/insert':
          this.menuStatus.insert = true;
          break;
        case '/update':
          this.menuStatus.update = true;
          break;
      }
    },
  },
  created() {
    var val = this.$store.state.currentPerms;
    var permsEntity = this.$store.state.permsEntity;
    for (var i = 0; i < permsEntity.length; i++) {
      if (permsEntity[i].perms == val) {
        this.showPermsMenu(permsEntity[i]);
      }
    }
    this.getDepTree();
    this.getMenuTree();
  },
};
</script>
<style lang="less" scoped>
//@import url(); 引入公共css类
.menuSettings_box {
  height: 98%;
  width: 98%;
  padding: 1%;
  position: absolute;
  .menuSettings_tree {
    display: flex;
    justify-content: space-around;
    width: 100%;
    height: 100%;
    .content_box {
      padding: 10px;
      width: 31%;
      height: 94%;
      border: 1px solid rgb(202, 201, 204);
      border-radius: 5px;
      /deep/ .el-input__inner {
        background-color: transparent !important;
        border: 1px solid;
        color: white;
      }
      /deep/.el-form-item__label {
        color: white;
      }
      /*修改table 表体的背景颜色和文字颜色*/
      /deep/ .el-table {
        background-color: transparent;

        th,
        td {
          background-color: transparent;
        }
        .el-table__expanded-cell {
          background-color: transparent !important;
        }

        // 表头背景色
        th.el-table__cell {
          background-color: #303030;
          color: #fff;
        }
        tr > td {
          background-color: #303030;
          color: #fff;
        }

        // hover效果
        tr:hover > td {
          background-color: rgba(255, 255, 255, 0.1) !important;
        }

        tbody tr:hover {
          background-color: rgba(255, 255, 255, 0.1) !important;
          // text-align: center;
        }

        // 滚动条宽高
        .el-table__body-wrapper::-webkit-scrollbar {
          width: 5px;
          height: 5px;
        }

        .el-table__body-wrapper::-webkit-scrollbar {
          width: 5px;
          /*滚动条宽度*/
          height: 10px;
          /*滚动条高度*/
        }
        /*定义滚动条轨道 内阴影+圆角*/
        .el-table__body-wrapper::-webkit-scrollbar-track {
          box-shadow: 0px 1px 3px #216fe6 inset;
          /*滚动条的背景区域的内阴影*/
          border-radius: 10px;
        }

        /*定义滑块 内阴影+圆角*/
        .el-table__body-wrapper::-webkit-scrollbar-thumb {
          box-shadow: 0px 1px 3px #216fe6 inset;
          border-radius: 6px;
          background-color: #216fe6;
        }
      }
    }
    .menuContent {
      height: 90%;
      overflow: auto;
    }
  }
  /deep/ .el-table {
    background-color: transparent;

    th,
    td {
      background-color: transparent;
    }
    .el-table__expanded-cell {
      background-color: transparent !important;
    }

    // 表头背景色
    th.el-table__cell {
      background-color: #303030;
      color: #fff;
    }
    tr > td {
      background-color: #303030;
      color: #fff;
    }

    // hover效果
    tr:hover > td {
      background-color: rgba(255, 255, 255, 0.1) !important;
    }

    tbody tr:hover {
      background-color: rgba(255, 255, 255, 0.1) !important;
      // text-align: center;
    }

    // 滚动条宽高
    .el-table__body-wrapper::-webkit-scrollbar {
      width: 5px;
      height: 5px;
    }

    .el-table__body-wrapper::-webkit-scrollbar {
      width: 5px;
      /*滚动条宽度*/
      height: 10px;
      /*滚动条高度*/
    }
    /*定义滚动条轨道 内阴影+圆角*/
    .el-table__body-wrapper::-webkit-scrollbar-track {
      box-shadow: 0px 1px 3px #216fe6 inset;
      /*滚动条的背景区域的内阴影*/
      border-radius: 10px;
    }

    /*定义滑块 内阴影+圆角*/
    .el-table__body-wrapper::-webkit-scrollbar-thumb {
      box-shadow: 0px 1px 3px #216fe6 inset;
      border-radius: 6px;
      background-color: #216fe6;
    }
  }
  .pagination_box {
    /deep/.el-input__inner {
      background-color: transparent !important;
      border: 1px solid;
      color: white;
    }
    /deep/.el-pagination__total {
      color: white;
    }
    /deep/.el-pagination__jump {
      color: white;
    }
    /deep/.el-pager li.active {
      color: #1890ff;
    }
    /deep/.el-pager li {
      color: white;
      background: transparent;
    }
    /deep/.el-pager li {
      color: white;
    }
    /deep/.btn-prev {
      background: transparent;
    }
    /deep/.btn-next {
      background: transparent;
    }
  }
  /deep/ .el-dialog {
    background: #303030;
  }
  /deep/.el-range-editor.is-active,
  .el-range-editor.is-active:hover,
  .el-select .el-input.is-focus .el-input__inner {
    border: 1px solid;
  }
  /deep/.el-dialog__title {
    color: white;
  }
/* //右侧和下方的白边 */
  /deep/.el-scrollbar__wrap{
   height: 1000px !important;
  }
  .divider {
    margin-top: 8px;
  }
}
</style>
<style>
.el-tree .el-icon-caret-right:before {
  color: white !important; /** 这里是要修改图标的颜色 **/
}
.el-tree {
  color: white !important; /** 这里是要修改图标的颜色 **/
  background: transparent !important;
}
.el-tree-node__content {
  background: transparent !important;
}

.el-tree-node.is-current > .el-tree-node__content {
  background-color: rgba(255, 255, 255, 0.1) !important;
  color: #409eff;
}
/*里面的代码可以根据自己需求去进行更改*/
/* 设置滚动条的样式 */
::-webkit-scrollbar {
  width: 4px;
}
/* 滚动槽 */
::-webkit-scrollbar-track {
  -webkit-box-shadow: inset006pxrgba(0, 0, 0, 0.3);
  border-radius: 10px;
}
/* 滚动条滑块 */
::-webkit-scrollbar-thumb {
  border-radius: 10px;
  background: #8b8b8b;
  -webkit-box-shadow: inset006pxrgba(0, 0, 0, 0.5);
}
::-webkit-scrollbar-thumb:window-inactive {
  background: #8b8b8b;
  height: 289px;
}
.el-select-dropdown {
  background: #303030;
  border-color: white;
}
/* //右侧和下方的白边 */
.el-scrollbar__wrap {
  margin-bottom: -20px !important;
  margin-right: -20px !important;
 
}
.el-select-dropdown__item.hover,
.el-select-dropdown__item:hover {
  background: rgba(0, 0, 0, 0.1) !important;
}
.el-select-dropdown__item {
  color: white;
}
</style>
